- Qt 5.15
- Qt 3D
- C++ Classes
- QAbstractAnimation
- Qt 5.15.11 Reference Documentation

# QAbstractAnimation Class

class Qt3DAnimation::QAbstractAnimation

An abstract base class for Qt3D animations. More...

Header: | #include <QAbstractAnimation>
qmake: | QT += 3danimation
Since: | Qt 5.9
Instantiated By: | AbstractAnimation
Inherited By: | Qt3DAnimation::QKeyframeAnimation, Qt3DAnimation::QMorphingAnimation, and Qt3DAnimation::QVertexBlendAnimation

This class was introduced in Qt 5.9.

- List of all members, including inherited members

## Public Types

enum | AnimationType { KeyframeAnimation, MorphingAnimation, VertexBlendAnimation }

## Properties

- animationName : QString
- animationType : const AnimationType
- duration : const float
- position : float

## Public Functions

QString | animationName() const
QAbstractAnimation::AnimationType | animationType() const
float | duration() const
float | position() const

## Public Slots

void | setAnimationName(const QString &name)
void | setPosition(float position)

## Signals

void | animationNameChanged(const QString &name)
void | durationChanged(float duration)
void | positionChanged(float position)

## Protected Functions

void | setDuration(float duration)

## Detailed Description

Qt3DAnimation::QAbstractAnimation is an abstract base class for all animations. Qt3DAnimation::QAbstractAnimation can not be directly instantiated, but rather through its subclasses. QAbstractAnimation specifies common properties for all Qt3D animations, such as animation name and type, current position and animation duration, while leaving the actual animating for the subclasses.

## Member Type Documentation

### enum QAbstractAnimation::AnimationType

This enumeration specifies the type of the animation

Constant | Value | Description
--- | --- | ---
`Qt3DAnimation::QAbstractAnimation::KeyframeAnimation` | `1` | Simple keyframe animation implementation for QTransform
`Qt3DAnimation::QAbstractAnimation::MorphingAnimation` | `2` | Blend-shape morphing animation
`Qt3DAnimation::QAbstractAnimation::VertexBlendAnimation` | `3` | Vertex-blend animation

## Property Documentation

### animationName : QString

Holds the name of the animation.

Access functions:

QString | animationName() const
void | setAnimationName(const QString &name)

Notifier signal:

void | animationNameChanged(const QString &name)

### animationType : const AnimationType

Holds the type of the animation.

Access functions:

QAbstractAnimation::AnimationType | animationType() const

### duration : const float

Holds the duration of the animation.

Access functions:

float | duration() const

Notifier signal:

void | durationChanged(float duration)

### position : float

Holds the current position of the animation.

Access functions:

float | position() const
void | setPosition(float position)

Notifier signal:

void | positionChanged(float position)

## Member Function Documentation

### `[protected]` void QAbstractAnimation::setDuration(float duration)

Sets the duration of the animation.

See also duration().